# Tunnel_C

Simple Tunnel Working on C

it can be used to small tunnel applications. 


### Compilation using GCC
 This software is known to have run for me under 
 Linux/Intel, Solaris/Intel, Solaris/Sparc, SunOS/Sparc.

```shell: 
 Linux:   gcc -O2 -Wall                          tunnel.c -o tunnel
 Solaris: gcc -O2 -Wall -lsocket -lnsl -DSOLARIS tunnel.c -o tunnel
 SunOS:   gcc -O2 -Wall                -DSUNOS   tunnel.c -o tunnel
```

### Implementation
#### help menu
```bash:
 tunnel -h 
```

#### example of HTTPS website
```bash:
 ./tunnel -Lr <ip_forClient_2_connect_as_public>:<public_port> <private_ip_or_local_ip_to_expose>:<private_port>
 ./tunnel -Lr 31.220.09.177:8878 23.87.270.189:5001
```
then open on your navigator "https://31.220.09.177:8878" and you will be taken to the https website that you are tunneling.

#### Diagram of Connection
Exposed IP(31.220.09.177:8878):<br>
       <tab><-------><<31.220.09.177:8878>>
                                     <----------><23.87.270.189:5001>
                                                                <---->PortForward<---->
                                                                                        <localIPwhereOF_the_https>
                                                                                        (192.168.1.7:57)









